<?php
if ( ! defined( 'ABSPATH' ) ) exit;

class BuiltPress_Import {

	public $error	= '';
	
	function __construct()
	{
		add_action( 'admin_menu', array( &$this, 'init' ) );
	}
	
	function init()
	{
		add_theme_page('Theme Import Demo', 'Theme Import Demo', 'manage_options', 'st_import', array( $this, 'slice_import' ));
	}
	
	function import_content( $folder = '', $file = 'content.xml' )
	{
		$import = new WP_Import();
		$xml = SLICETHEME_PLUGIN_PATH .'/import/files/'. $folder .'/'. $file;
		print_r($xml);
		$import->fetch_attachments = ( $_POST && key_exists('attachments', $_POST) && $_POST['attachments'] ) ? true : false;
		
		ob_start();
		$import->import( $xml );	
		ob_end_clean();
	}	
	
	function import_menus( $folder = '', $file = 'menus.txt' )
	{
		/*$file_path 	= SLICETHEME_PLUGIN_PATH .'/import/files/'. $folder .'/'. $file;
		$file_data 	= $this->get_file_contents( $file_path );
		$data 		= json_decode($file_data, true);
		$menus 		= wp_get_nav_menus();
			
		foreach( $data as $key => $val ){
			foreach( $menus as $menu ){
				if( $menu->slug == $val ){
					$data[$key] = absint( $menu->term_id );
				}
			}
		}
		
		set_theme_mod( 'nav_menu_locations', array_map('absint', $data ) );*/
		 $top_menu = get_term_by( 'name', 'Main Menu', 'nav_menu' );

            if ( isset( $top_menu->term_id ) ) {
                set_theme_mod( 'nav_menu_locations', array(
                        'primary' => $top_menu->term_id,
                        'social'  => $top_menu->term_id
                    )
                );
            }
	}

	function wie_import_data( $data ) {
		print_r($data);
	global $wp_registered_sidebars;

	// Have valid data?
	// If no data or could not decode
	if ( empty( $data ) || ! is_object( $data ) ) {
		wp_die(
			esc_html__( 'Import data could not be read. Please try a different file.', 'widget-importer-exporter' ),
			'',
			array( 'back_link' => true )
		);
	}

	// Hook before import
	do_action( 'wie_before_import' );
	$data = apply_filters( 'wie_import_data', $data );

	// Get all available widgets site supports
	$available_widgets = wie_available_widgets();

	// Get all existing widget instances
	$widget_instances = array();
	foreach ( $available_widgets as $widget_data ) {
		$widget_instances[$widget_data['id_base']] = get_option( 'widget_' . $widget_data['id_base'] );
	}

	// Begin results
	$results = array();

	// Loop import data's sidebars
	foreach ( $data as $sidebar_id => $widgets ) {

		// Skip inactive widgets
		// (should not be in export file)
		if ( 'wp_inactive_widgets' == $sidebar_id ) {
			continue;
		}

		// Check if sidebar is available on this site
		// Otherwise add widgets to inactive, and say so
		if ( isset( $wp_registered_sidebars[$sidebar_id] ) ) {
			$sidebar_available = true;
			$use_sidebar_id = $sidebar_id;
			$sidebar_message_type = 'success';
			$sidebar_message = '';
		} else {
			$sidebar_available = false;
			$use_sidebar_id = 'wp_inactive_widgets'; // add to inactive if sidebar does not exist in theme
			$sidebar_message_type = 'error';
			$sidebar_message = esc_html__( 'Sidebar does not exist in theme (using Inactive)', 'widget-importer-exporter' );
		}

		// Result for sidebar
		$results[$sidebar_id]['name'] = ! empty( $wp_registered_sidebars[$sidebar_id]['name'] ) ? $wp_registered_sidebars[$sidebar_id]['name'] : $sidebar_id; // sidebar name if theme supports it; otherwise ID
		$results[$sidebar_id]['message_type'] = $sidebar_message_type;
		$results[$sidebar_id]['message'] = $sidebar_message;
		$results[$sidebar_id]['widgets'] = array();

		// Loop widgets
		foreach ( $widgets as $widget_instance_id => $widget ) {

			$fail = false;

			// Get id_base (remove -# from end) and instance ID number
			$id_base = preg_replace( '/-[0-9]+$/', '', $widget_instance_id );
			$instance_id_number = str_replace( $id_base . '-', '', $widget_instance_id );

			// Does site support this widget?
			if ( ! $fail && ! isset( $available_widgets[$id_base] ) ) {
				$fail = true;
				$widget_message_type = 'error';
				$widget_message = esc_html__( 'Site does not support widget', 'widget-importer-exporter' ); // explain why widget not imported
			}

			// Filter to modify settings object before conversion to array and import
			// Leave this filter here for backwards compatibility with manipulating objects (before conversion to array below)
			// Ideally the newer wie_widget_settings_array below will be used instead of this
			$widget = apply_filters( 'wie_widget_settings', $widget ); // object

			// Convert multidimensional objects to multidimensional arrays
			// Some plugins like Jetpack Widget Visibility store settings as multidimensional arrays
			// Without this, they are imported as objects and cause fatal error on Widgets page
			// If this creates problems for plugins that do actually intend settings in objects then may need to consider other approach: https://wordpress.org/support/topic/problem-with-array-of-arrays
			// It is probably much more likely that arrays are used than objects, however
			$widget = json_decode( json_encode( $widget ), true );

			// Filter to modify settings array
			// This is preferred over the older wie_widget_settings filter above
			// Do before identical check because changes may make it identical to end result (such as URL replacements)
			$widget = apply_filters( 'wie_widget_settings_array', $widget );

			// Does widget with identical settings already exist in same sidebar?
			if ( ! $fail && isset( $widget_instances[$id_base] ) ) {

				// Get existing widgets in this sidebar
				$sidebars_widgets = get_option( 'sidebars_widgets' );
				$sidebar_widgets = isset( $sidebars_widgets[$use_sidebar_id] ) ? $sidebars_widgets[$use_sidebar_id] : array(); // check Inactive if that's where will go

				// Loop widgets with ID base
				$single_widget_instances = ! empty( $widget_instances[$id_base] ) ? $widget_instances[$id_base] : array();
				foreach ( $single_widget_instances as $check_id => $check_widget ) {

					// Is widget in same sidebar and has identical settings?
					if ( in_array( "$id_base-$check_id", $sidebar_widgets ) && (array) $widget == $check_widget ) {

						$fail = true;
						$widget_message_type = 'warning';
						$widget_message = esc_html__( 'Widget already exists', 'widget-importer-exporter' ); // explain why widget not imported

						break;

					}

				}

			}

			// No failure
			if ( ! $fail ) {

				// Add widget instance
				$single_widget_instances = get_option( 'widget_' . $id_base ); // all instances for that widget ID base, get fresh every time
				$single_widget_instances = ! empty( $single_widget_instances ) ? $single_widget_instances : array( '_multiwidget' => 1 ); // start fresh if have to
				$single_widget_instances[] = $widget; // add it

					// Get the key it was given
					end( $single_widget_instances );
					$new_instance_id_number = key( $single_widget_instances );

					// If key is 0, make it 1
					// When 0, an issue can occur where adding a widget causes data from other widget to load, and the widget doesn't stick (reload wipes it)
					if ( '0' === strval( $new_instance_id_number ) ) {
						$new_instance_id_number = 1;
						$single_widget_instances[$new_instance_id_number] = $single_widget_instances[0];
						unset( $single_widget_instances[0] );
					}

					// Move _multiwidget to end of array for uniformity
					if ( isset( $single_widget_instances['_multiwidget'] ) ) {
						$multiwidget = $single_widget_instances['_multiwidget'];
						unset( $single_widget_instances['_multiwidget'] );
						$single_widget_instances['_multiwidget'] = $multiwidget;
					}

					// Update option with new widget
					update_option( 'widget_' . $id_base, $single_widget_instances );

				// Assign widget instance to sidebar
				$sidebars_widgets = get_option( 'sidebars_widgets' ); // which sidebars have which widgets, get fresh every time
				$new_instance_id = $id_base . '-' . $new_instance_id_number; // use ID number from new widget instance
				$sidebars_widgets[$use_sidebar_id][] = $new_instance_id; // add new instance to sidebar
				update_option( 'sidebars_widgets', $sidebars_widgets ); // save the amended data

				// After widget import action
				$after_widget_import = array(
					'sidebar'           => $use_sidebar_id,
					'sidebar_old'       => $sidebar_id,
					'widget'            => $widget,
					'widget_type'       => $id_base,
					'widget_id'         => $new_instance_id,
					'widget_id_old'     => $widget_instance_id,
					'widget_id_num'     => $new_instance_id_number,
					'widget_id_num_old' => $instance_id_number
				);
				do_action( 'wie_after_widget_import', $after_widget_import );

				// Success message
				if ( $sidebar_available ) {
					$widget_message_type = 'success';
					$widget_message = esc_html__( 'Imported', 'widget-importer-exporter' );
				} else {
					$widget_message_type = 'warning';
					$widget_message = esc_html__( 'Imported to Inactive', 'widget-importer-exporter' );
				}

			}

			// Result for widget instance
			$results[$sidebar_id]['widgets'][$widget_instance_id]['name'] = isset( $available_widgets[$id_base]['name'] ) ? $available_widgets[$id_base]['name'] : $id_base; // widget name or ID if name not available (not supported by site)
			$results[$sidebar_id]['widgets'][$widget_instance_id]['title'] = ! empty( $widget['title'] ) ? $widget['title'] : esc_html__( 'No Title', 'widget-importer-exporter' ); // show "No Title" if widget instance is untitled
			$results[$sidebar_id]['widgets'][$widget_instance_id]['message_type'] = $widget_message_type;
			$results[$sidebar_id]['widgets'][$widget_instance_id]['message'] = $widget_message;

		}

	}

	// Hook after import
	do_action( 'wie_after_import' );

	// Return results
	return apply_filters( 'wie_import_results', $results );

}




		
	function import_widgets( $folder = '', $file = 'widgets.txt' )
	{
		$file_path 	= SLICETHEME_PLUGIN_PATH .'/import/files/'. $folder .'/'. $file;
		//$file_data 	= $this->get_file_contents( $file_path );
		//$data 		= json_decode($file_data, true);print_r($data);
		$data = file_get_contents( $file_path );
		$data = json_decode( $data );
		$wie_import_results = wie_import_data( $data );
		
		/*foreach ((array) $data['widgets'] as $widget_id => $widget_data) {
			update_option( 'widget_' . $widget_id, $widget_data );
		}
		
		$slice_sidebars = get_option("sidebars_widgets");
		unset($slice_sidebars['array_version']);
		
		if ( is_array($data['sidebars']) ) {
			$slice_sidebars = array_merge( (array) $slice_sidebars, (array) $data['sidebars'] );
			unset($slice_sidebars['wp_inactive_widgets']);
			$slice_sidebars = array_merge(array('wp_inactive_widgets' => array()), $slice_sidebars);
			$slice_sidebars['array_version'] = 2;
			wp_set_sidebars_widgets($slice_sidebars);
		}*/
	}
	
	function import_options( $folder = '', $file = 'options.txt' )
	{
		$file_path 	= SLICETHEME_PLUGIN_PATH .'/import/files/'. $folder .'/'. $file;
		$file_data 	= $this->get_file_contents( $file_path );
		$data 		= json_decode($file_data, true);

		if( is_array( $data ) ){
			update_option('laundryes_option', $data);
		}
	}
	
	function import_revslider( $folder = '' )
	{
		if ( ! class_exists( 'RevSliderAdmin' ) ) {
			require_once RS_PLUGIN_PATH .'/admin/revslider-admin.class.php';
		}
		
		$rev_files = glob(SLICETHEME_PLUGIN_PATH .'/import/files/'. $folder .'/revslider/*.zip');
		
		if (!empty($rev_files)) {
			foreach ($rev_files as $rev_file) {
				$_FILES['import_file']['error'] = UPLOAD_ERR_OK;
				$_FILES['import_file']['tmp_name']= $rev_file;

				$slider = new RevSlider();
				$slider->importSliderFromPost( true, 'none' );
			}
		}
	}
	
	function get_file_contents( $path )
	{
        if ( function_exists('realpath') )
            $filepath = realpath($path);
        if ( !$filepath || !@is_file($filepath) )
            return '';
		
		global $wp_filesystem;
		if (empty($wp_filesystem)) {
			require_once ABSPATH .'/wp-admin/includes/file.php';
			WP_Filesystem();
		}
		
		return $wp_filesystem->get_contents($filepath);
    }
	
	function slice_import()
	{
		global $wpdb;
		
		if( key_exists( 'st_import_nonce',$_POST ) ){
			if ( wp_verify_nonce( $_POST['st_import_nonce'], basename(__FILE__) ) ){
				
// 				print_r($_POST);
	
				// Importer classes
				if( ! defined( 'WP_LOAD_IMPORTERS' ) ) define( 'WP_LOAD_IMPORTERS', true );
				
				if( ! class_exists( 'WP_Importer' ) ){
					require_once ABSPATH .'wp-admin/includes/class-wp-importer.php';
				}
				
				if( ! class_exists( 'WP_Import' ) ){
					require_once SLICETHEME_PLUGIN_PATH .'/import/wordpress-importer/wordpress-importer.php';
				}
				
				if( class_exists( 'WP_Importer' ) && class_exists( 'WP_Import' ) ){
					
					$import_folder = $_POST['import_folder'];
					
					switch( $_POST['import_type'] ) {
							
						case 'all':
							$this->import_content( $import_folder );
							$this->import_menus( $import_folder );
							$this->import_widgets( $import_folder );
							$this->import_options( $import_folder );
							if ( in_array('revslider/revslider.php', apply_filters('active_plugins', get_option('active_plugins'))) ) {
								$this->import_revslider( $import_folder );
							}
							
							// set home & blog page
							$home = get_page_by_title( 'Home' );
							$blog = get_page_by_title( 'Blog' );
							if( $home->ID && $blog->ID ) {
								update_option('show_on_front', 'page');
								update_option('page_on_front', $home->ID); // Front Page
								update_option('page_for_posts', $blog->ID); // Blog Page
							}
							break;
						
						case 'content':
							$this->import_content( $import_folder );
							break;
							
						case 'menus':
							$this->import_menus( $import_folder );
							break;
							
						case 'widgets':
							$this->import_widgets( $import_folder );
							break;
							
						case 'options':
							$this->import_options( $import_folder );
							break;
							
						case 'revslider':
							if ( in_array('revslider/revslider.php', apply_filters('active_plugins', get_option('active_plugins'))) ) {
								$this->import_revslider( $import_folder );
							}
							break;
							
						default:
							$this->error = esc_html__('Please select data to import.', 'builtpress');	
							break;
					}
					
					// message box
					if( $this->error ){
						echo '<div class="error settings-error">';
							echo '<p><strong>'. $this->error .'</strong></p>';
						echo '</div>';
					} else {
						echo '<div class="updated settings-error">';
							echo '<p><strong>'. esc_html__('All done. Have fun!', 'builtpress') .'</strong></p>';
						echo '</div>';
					}

				}
	
			}
		}

		?>
		<div class="wrap">		
			<h2><?php echo esc_html( get_admin_page_title() ); ?></h2>			
			<p><strong>Notice:</strong></p>
			<p>
				Before starting the import, you need to install all plugins that you want to use.<br />
				If you are planning to use the shop, please also remember about WooCommerce plugin.
			</p>	
			<form action="" method="post">				
				<input type="hidden" name="st_import_nonce" value="<?php echo wp_create_nonce(basename(__FILE__)); ?>" />				
				<table class="form-table" style="width:800px;">				
					<tr>
						<th scope="row">
							<label>Import</label>
							<p class="description">Choose demo content</p>
						</th>
						<td>
							<p class="description">Demo Site</p>
							<select name="import_folder" class="import" style="width:100%">
								<option value="demo">Original</option>
							</select>
						</td>
						<td>
							<p class="description">Import Type</p>
							<select name="import_type" class="import" style="width:100%">
								<option value="">-- Select --</option>
								<option value="all">All</option>
								<option value="content">Content</option>
								<option value="menus">Menus</option>
								<option value="widgets">Widgets</option>
								<option value="options">Options</option>
								<option value="revslider">Revolution Slider</option>
							</select>
						</td>
					</tr>
					<tr class="row-attachments hide">
						<th scope="row">Attachments</th>
						<td colspan="2">
							<fieldset>
								<label for="attachments"><input type="checkbox" value="1" id="attachments" name="attachments">Import attachments</label>
								<p class="description">Download all attachments from the demo may take a while. Please be patient.</p>
							</fieldset>
						</td>
					</tr>				
				</table>	
				<input type="submit" name="submit" class="button button-primary" value="Import Data" />					
			</form>	
		</div>	
		<?php	
	}
	
}

$ST_Import = new BuiltPress_Import();

if ( file_exists(SLICETHEME_PLUGIN_PATH .'/import/export.php') ) {
	require_once SLICETHEME_PLUGIN_PATH .'/import/export.php';
}