<?php
function register_package() {
 
    $labels = array(
        'name' => _x( 'Packages', 'packages' ),
        'singular_name' => _x( 'Package', 'package' ),
        'add_new' => _x( 'Add New', 'package' ),
        'add_new_item' => _x( 'Add New package', 'package' ),
        'edit_item' => _x( 'Edit Package', 'package' ),
        'new_item' => _x( 'New Package', 'package' ),
        'view_item' => _x( 'View Package', 'package' ),
        'search_items' => _x( 'Search Package', 'package' ),
        'not_found' => _x( 'No Package found', 'package' ),
        'not_found_in_trash' => _x( 'No Package found in Trash', 'package' ),
        'menu_name' => _x( 'Package', 'package' ),
    );
 
    $args = array(
        'labels' => $labels,
        'hierarchical' => true,
        'description' => 'Package filterable by Teams',
        'supports'           => array( 'title'),
        'taxonomies' => array( 'Category' ),
        'public' => true,
        'show_ui' => true,
        'show_in_menu' => true,
        'menu_position' => 5,
        'menu_icon' => 'dashicons-groups',
        'show_in_nav_menus' => true,
        'publicly_queryable' => true,
        'exclude_from_search' => false,
        'has_archive' => true,
        'query_var' => true,
        'can_export' => true,
        'rewrite' => true,
        'capability_type' => 'post'
    );
 
    register_post_type( 'package', $args );
}
 
add_action( 'init', 'register_package' );
add_action( 'admin_init', 'package_meta' );
function package_meta() {
    add_meta_box( 'package_meta_box',
        'Packages Details',
        'display_package_meta_box',
        'package', 'normal', 'high'
    );
}
/*function register_post_assets(){
   
}
add_action('admin_init', 'register_post_assets', 1);
*/

function display_package_meta_box( $package ) {
    // Retrieve current name of the Name and package Rating based on review ID
    $pricesymbol = esc_html( get_post_meta( $package->ID, 'pricesymbol', true ) );
	$price = esc_html( get_post_meta( $package->ID, 'price', true ) );
	$option1 = esc_html( get_post_meta( $package->ID, 'option1', true ) );
    $option2 = esc_html( get_post_meta( $package->ID, 'option2', true ) );
    $option3 = esc_html( get_post_meta( $package->ID, 'option3', true ) );
	$option4 = esc_html( get_post_meta( $package->ID, 'option4', true ) );
	$option5 = esc_html( get_post_meta( $package->ID, 'option5', true ) );
    $btntitle = esc_html( get_post_meta( $package->ID, 'btntitle', true ) );
	$link = esc_html( get_post_meta( $package->ID, 'link', true ) );
	
   
    
    ?>
    <table>
    <tr>
            <td style="width: 100%">Price Symbol: </td>
            <td><input type="text" size="80" name="pricesymbol" value="<?=$pricesymbol; ?>" /></td>
        </tr>
     <tr>
            <td style="width: 100%">Price : </td>
            <td><input type="text" size="80" name="price" value="<?=$price; ?>" /></td>
        </tr>
        <tr>
            <td style="width: 100%">Option 1 : </td>
            <td><input type="text" size="80" name="option1" value="<?=$option1; ?>" /></td>
        </tr>
       
        <tr>
            <td  style="width: 100%">Option 2 : </td>
             <td><input type="text" size="80" name="option2" value="<?=$option2; ?>" /></td>
        </tr>
        <tr>
            <td style="width: 100%">Option 3 : </td>
             <td><input type="text" size="80" name="option3" value="<?=$option3; ?>" /></td>
        </tr>
        <tr>
            <td style="width: 100%">Option 4 : </td>
             <td><input type="text" size="80" name="option4" value="<?=$option4; ?>" /></td>
        </tr>
        <tr>
            <td style="width: 100%">Option 5 : </td>
             <td><input type="text" size="80" name="option5" value="<?=$option5; ?>" /></td>
        </tr>
        <tr>
            <td style="width: 100%">Button Title : </td>
             <td><input type="text" size="80" name="btntitle" value="<?=get_post_meta( $package->ID, 'btntitle', true ); ?>" /></td>
        </tr>
        <tr>
            <td style="width: 100%">Order Link : </td>
             <td><input type="text" size="80" name="link" value="<?=$link; ?>" /></td>
        </tr>
       

    </table>
    <?php
}

add_action( 'save_post', 'add_package_fields', 10, 2 );

function add_package_fields( $package_id, $package ) {
    // Check post type for package reviews
    if ( $package->post_type == 'package' ) {
        // Store data in post meta table if present in post data

		if ( isset( $_POST['pricesymbol'] ) && $_POST['pricesymbol'] != '' ) {
            update_post_meta( $package_id, 'pricesymbol', $_POST['pricesymbol'] );
        }
		if ( isset( $_POST['price'] ) && $_POST['price'] != '' ) {
            update_post_meta( $package_id, 'price', $_POST['price'] );
        }
        if ( isset( $_POST['option1'] ) && $_POST['option1'] != '' ) {
            update_post_meta( $package_id, 'option1', $_POST['option1'] );
        }
		
        if ( isset( $_POST['option2'] ) && $_POST['option2'] != '' ) {
            update_post_meta( $package_id, 'option2', $_POST['option2'] );
        }
		 if ( isset( $_POST['option3'] ) && $_POST['option3'] != '' ) {
            update_post_meta( $package_id, 'option3', $_POST['option3'] );
        }
		 if ( isset( $_POST['option4'] ) && $_POST['option4'] != '' ) {
            update_post_meta( $package_id, 'option4', $_POST['option4'] );
        }
        if ( isset( $_POST['option5'] ) && $_POST['option5'] != '' ) {
            update_post_meta( $package_id, 'option5', $_POST['option5'] );
        }
         if ( isset( $_POST['btntitle'] ) ) {
            update_post_meta( $package_id, 'btntitle', $_POST['btntitle'] );
        }
		 if ( isset( $_POST['link'] ) ) {
            update_post_meta( $package_id, 'link', $_POST['link'] );
        }
		 
    }
}
//add_filter( 'template_include', 'include_template_function');








function register_cpt_testimonial() {
 
    $labels = array(
        'name' => _x( 'Testimonial', 'testimonial' ),
        'singular_name' => _x( 'Testimonial', 'testimonial' ),
        'add_new' => _x( 'Add New', 'testimonial' ),
        'add_new_item' => _x( 'Add New Testimonial', 'testimonial' ),
        'edit_item' => _x( 'Edit Testimonial', 'testimonial' ),
        'new_item' => _x( 'New Testimonial', 'testimonial' ),
        'view_item' => _x( 'View Testimonial', 'testimonial' ),
        'search_items' => _x( 'Search Testimonial', 'testimonial' ),
        'not_found' => _x( 'No Testimonial found', 'testimonial' ),
        'not_found_in_trash' => _x( 'No Testimonial found in Trash', 'testimonial' ),
        'parent_item_colon' => _x( 'Parent Testimonial:', 'testimonial' ),
        'menu_name' => _x( 'Testimonial', 'testimonial' ),
    );
 
    $args = array(
        'labels' => $labels,
        'hierarchical' => true,
        'description' => 'Testimonial filterable by Catagory',
        'supports' => array( 'title', 'editor','thumbnail', 'page-attributes' ),
        'taxonomies' => array( 'Catagories' ),
        'public' => true,
        'show_ui' => true,
        'show_in_menu' => true,
        'menu_position' => 5,
        'menu_icon' => 'dashicons-category',
        'show_in_nav_menus' => true,
        'publicly_queryable' => true,
        'exclude_from_search' => false,
        'has_archive' => true,
        'query_var' => true,
        'can_export' => true,
        'rewrite' => true,
        'capability_type' => 'post'
    );
 
    register_post_type( 'testimonial', $args );
}
 
add_action( 'init', 'register_cpt_testimonial' );
 

// Function used to automatically create Testimonial page.
function create_testimonial_pages()
  {
   //post status and options
    $post = array(
          'comment_status' => 'open',
          'ping_status' =>  'closed' ,
          'post_date' => date('Y-m-d H:i:s'),
          'post_name' => 'testimonial',
          'post_status' => 'publish' ,
          'post_title' => 'Testimonial',
          'post_type' => 'page',
    );
    //insert page and save the id
    $newvalue = wp_insert_post( $post, false );
    //save the id in the database
    update_option( 'mrpage', $newvalue );
  }
  // // Activates function if plugin is activated
register_activation_hook( __FILE__, 'create_testimonial_pages');

/**************************************************/
add_action( 'admin_init', 'testimonia_admin' );
function testimonia_admin() {
    add_meta_box( 'testimonial_meta_box',
        'Testimonial Details',
        'display_testimonial_meta_box',
        'testimonial', 'normal', 'high'
    );
}
function display_testimonial_meta_box( $testimonial ) {
    // Retrieve current name of the Director and Movie Rating based on review ID
    $testimonial_author_name = esc_html( get_post_meta( $testimonial->ID, 'testimonial_author_name', true ) );
  $testimonial_web_name = esc_html( get_post_meta( $testimonial->ID, 'testimonial_web_name', true ) );
    $testimonial_web_url = esc_html( get_post_meta( $testimonial->ID, 'testimonial_web_url', true ) );
    ?>
    <table>
        <tr>
            <td style="width: 100%">Author occupation</td>
            <td><input type="text" size="80" name="testimonial_author_name" value="<?php echo $testimonial_author_name; ?>" /></td>
        </tr>
         <tr>
            <td style="width: 100%">Website Name:</td>
            <td><input type="text" size="80" name="testimonial_web_name" value="<?php echo $testimonial_web_name; ?>" /></td>
        </tr>
         <tr>
            <td style="width: 100%">Website URL:</td>
            <td><input type="text" size="80" name="testimonial_web_url" value="<?php echo $testimonial_web_url; ?>" /></td>
        </tr>
    </table>
    <?php
}
add_action( 'save_post', 'add_testimonial_fields', 10, 2 );

function add_testimonial_fields( $testimonial_id, $testimonial ) {
    // Check post type for testimonial reviews
    if ( $testimonial->post_type == 'testimonial' ) {
        // Store data in post meta table if present in post data
        if ( isset( $_POST['testimonial_author_name'] ) && $_POST['testimonial_author_name'] != '' ) {
            update_post_meta( $testimonial_id, 'testimonial_author_name', $_POST['testimonial_author_name'] );
        }
        if ( isset( $_POST['testimonial_web_name'] ) && $_POST['testimonial_web_name'] != '' ) {
            update_post_meta( $testimonial_id, 'testimonial_web_name', $_POST['testimonial_web_name'] );
        }
     if ( isset( $_POST['testimonial_web_url'] ) && $_POST['testimonial_web_url'] != '' ) {
            update_post_meta( $testimonial_id, 'testimonial_web_url', $_POST['testimonial_web_url'] );
        }
    }
}

add_filter( 'template_include', 'include_template_function_testimonials');
function include_template_function_testimonials( $template_path ) {
    if ( get_post_type() == 'testimonial' ) {    
        if ( is_single() ) {
                $template_path = get_template_directory() . '/inc/single-testimonial.php';
        }
    }
    return $template_path;
}

 ?>